- name: Create tls certificates
  when: not k8s_ska_ser_namespace_values.api.pki.createSelfSignedCert
  become: true
  block:
    - name: Issue tls certificates
      ansible.builtin.import_role:
        name: ska_collections.instance_common.certs
        tasks_from: sign-cert
      vars:
        certificate_name: "{{ k8s_ska_ser_namespace_api_svc_name }}"
        certificate_dns_alt_name: "{{ k8s_ska_ser_namespace_api_svc_name }}.{{ k8s_ska_ser_namespace_manager_namespace }}.svc"
        certificate_extra_alt_names:
          - "DNS:{{ k8s_ska_ser_namespace_api_svc_name }}.{{ k8s_ska_ser_namespace_manager_namespace }}"

    - name: Slurp ca certificate
      ansible.builtin.slurp:
        src: "{{ certificates_dir }}/ca-certificate.crt"
      register: slurped_ca

    - name: Slurp certificate key
      ansible.builtin.slurp:
        src: "{{ certificates_dir }}/{{ k8s_ska_ser_namespace_api_svc_name }}.key"
      register: slurped_key

    - name: Slurp certificate
      ansible.builtin.slurp:
        src: "{{ certificates_dir }}/{{ k8s_ska_ser_namespace_api_svc_name }}.crt"
      register: slurped_cert

    - name: Inject tls certificates into values
      ansible.builtin.set_fact:
        api_pki_values:
          api:
            pki:
              ca: "{{ slurped_ca.content | b64decode }}"
              key: "{{ slurped_key.content | b64decode }}"
              cert: "{{ slurped_cert.content | b64decode }}"

- name: Install ska-ser-namespace-manager
  kubernetes.core.helm:
    wait: true
    chart_repo_url: "{{ k8s_ska_ser_namespace_manager_helm_chart_repo }}"
    chart_ref: "{{ k8s_ska_ser_namespace_manager_helm_chart }}"
    chart_version: "{{ k8s_ska_ser_namespace_manager_helm_chart_version }}"
    create_namespace: true
    namespace: "{{ k8s_ska_ser_namespace_manager_namespace }}"
    name: "{{ k8s_ska_ser_namespace_manager_release }}"
    values: "{{ k8s_ska_ser_namespace_values | combine((api_pki_values | default({})), recursive=True) }}"
    wait_timeout: 120s
